include Ctypes
let lift x = x
open Ctypes_static

let field : type a s. 't typ -> string -> a typ ->
  (a, ((s, [<`Struct | `Union]) structured as 't)) field =
  fun (type k) (s : (_, k) structured typ) fname ftype -> match s, fname with
  | _ -> failwith ("Unexpected field "^ fname)

let seal (type t) (t : (_, t) structured typ) = match t with
  | Struct { tag; spec = Complete _; } ->
    raise (ModifyingSealedType tag)
  | Union { utag; uspec = Some _; } ->
    raise (ModifyingSealedType utag)
  | _ ->
    raise (Unsupported "Sealing a non-structured type")
type 'a const = 'a
let constant (type t) name (t : t typ) : t = match name, t with
  | "PCI_CB_SUBSYSTEM_ID", Ctypes_static.Primitive Cstubs_internals.Int ->
    66
  | "PCI_CB_SUBSYSTEM_VENDOR_ID", Ctypes_static.Primitive Cstubs_internals.Int ->
    64
  | "PCI_HEADER_TYPE_CARDBUS", Ctypes_static.Primitive Cstubs_internals.Int ->
    2
  | "PCI_SUBSYSTEM_ID", Ctypes_static.Primitive Cstubs_internals.Int ->
    46
  | "PCI_SUBSYSTEM_VENDOR_ID", Ctypes_static.Primitive Cstubs_internals.Int ->
    44
  | "PCI_HEADER_TYPE_NORMAL", Ctypes_static.Primitive Cstubs_internals.Int ->
    0
  | "PCI_HEADER_TYPE", Ctypes_static.Primitive Cstubs_internals.Int ->
    14
  | "PCI_CLASS_OTHERS", Ctypes_static.Primitive Cstubs_internals.Int ->
    255
  | "PCI_BASE_CLASS_SIGNAL", Ctypes_static.Primitive Cstubs_internals.Int ->
    17
  | "PCI_BASE_CLASS_CRYPT", Ctypes_static.Primitive Cstubs_internals.Int ->
    16
  | "PCI_BASE_CLASS_SATELLITE", Ctypes_static.Primitive Cstubs_internals.Int ->
    15
  | "PCI_BASE_CLASS_INTELLIGENT", Ctypes_static.Primitive Cstubs_internals.Int ->
    14
  | "PCI_BASE_CLASS_WIRELESS", Ctypes_static.Primitive Cstubs_internals.Int ->
    13
  | "PCI_BASE_CLASS_SERIAL", Ctypes_static.Primitive Cstubs_internals.Int ->
    12
  | "PCI_BASE_CLASS_PROCESSOR", Ctypes_static.Primitive Cstubs_internals.Int ->
    11
  | "PCI_BASE_CLASS_DOCKING", Ctypes_static.Primitive Cstubs_internals.Int ->
    10
  | "PCI_BASE_CLASS_INPUT", Ctypes_static.Primitive Cstubs_internals.Int ->
    9
  | "PCI_BASE_CLASS_SYSTEM", Ctypes_static.Primitive Cstubs_internals.Int ->
    8
  | "PCI_BASE_CLASS_COMMUNICATION", Ctypes_static.Primitive Cstubs_internals.Int ->
    7
  | "PCI_BASE_CLASS_BRIDGE", Ctypes_static.Primitive Cstubs_internals.Int ->
    6
  | "PCI_BASE_CLASS_MEMORY", Ctypes_static.Primitive Cstubs_internals.Int ->
    5
  | "PCI_BASE_CLASS_MULTIMEDIA", Ctypes_static.Primitive Cstubs_internals.Int ->
    4
  | "PCI_BASE_CLASS_DISPLAY", Ctypes_static.Primitive Cstubs_internals.Int ->
    3
  | "PCI_BASE_CLASS_NETWORK", Ctypes_static.Primitive Cstubs_internals.Int ->
    2
  | "PCI_BASE_CLASS_STORAGE", Ctypes_static.Primitive Cstubs_internals.Int ->
    1
  | "PCI_CLASS_NOT_DEFINED", Ctypes_static.Primitive Cstubs_internals.Int ->
    0
  | "PCI_FILL_RESCAN", Ctypes_static.Primitive Cstubs_internals.Int ->
    65536
  | "PCI_FILL_MODULE_ALIAS", Ctypes_static.Primitive Cstubs_internals.Int ->
    512
  | "PCI_FILL_PHYS_SLOT", Ctypes_static.Primitive Cstubs_internals.Int ->
    256
  | "PCI_FILL_EXT_CAPS", Ctypes_static.Primitive Cstubs_internals.Int ->
    128
  | "PCI_FILL_CAPS", Ctypes_static.Primitive Cstubs_internals.Int ->
    64
  | "PCI_FILL_CLASS", Ctypes_static.Primitive Cstubs_internals.Int ->
    32
  | "PCI_FILL_SIZES", Ctypes_static.Primitive Cstubs_internals.Int ->
    16
  | "PCI_FILL_ROM_BASE", Ctypes_static.Primitive Cstubs_internals.Int ->
    8
  | "PCI_FILL_BASES", Ctypes_static.Primitive Cstubs_internals.Int ->
    4
  | "PCI_FILL_IRQ", Ctypes_static.Primitive Cstubs_internals.Int ->
    2
  | "PCI_FILL_IDENT", Ctypes_static.Primitive Cstubs_internals.Int ->
    1
  | "PCI_LOOKUP_REFRESH_CACHE", Ctypes_static.Primitive Cstubs_internals.Int ->
    4194304
  | "PCI_LOOKUP_CACHE", Ctypes_static.Primitive Cstubs_internals.Int ->
    2097152
  | "PCI_LOOKUP_SKIP_LOCAL", Ctypes_static.Primitive Cstubs_internals.Int ->
    1048576
  | "PCI_LOOKUP_NETWORK", Ctypes_static.Primitive Cstubs_internals.Int ->
    524288
  | "PCI_LOOKUP_MIXED", Ctypes_static.Primitive Cstubs_internals.Int ->
    262144
  | "PCI_LOOKUP_NO_NUMBERS", Ctypes_static.Primitive Cstubs_internals.Int ->
    131072
  | "PCI_LOOKUP_NUMERIC", Ctypes_static.Primitive Cstubs_internals.Int ->
    65536
  | "PCI_LOOKUP_PROGIF", Ctypes_static.Primitive Cstubs_internals.Int ->
    16
  | "PCI_LOOKUP_SUBSYSTEM", Ctypes_static.Primitive Cstubs_internals.Int ->
    8
  | "PCI_LOOKUP_CLASS", Ctypes_static.Primitive Cstubs_internals.Int ->
    4
  | "PCI_LOOKUP_DEVICE", Ctypes_static.Primitive Cstubs_internals.Int ->
    2
  | "PCI_LOOKUP_VENDOR", Ctypes_static.Primitive Cstubs_internals.Int ->
    1
  | s, _ -> failwith ("unmatched constant: "^ s)

let enum (type a) name ?unexpected (alist : (a * int64) list) =
  match name with
  | s ->
    failwith ("unmatched enum: "^ s)
